#include    "lib.h"

//
// RANDOM.S
//
extern	unsigned char	RandomValue;
extern	void		GetRand();


extern	void	_InitTables();


extern	unsigned char	X0;
extern	unsigned char	Y0;
extern	unsigned char	X1;
extern	unsigned char	Y1;

extern	void AddLineASM();

extern	void FillTablesASM();

extern	void ClearAndSwapFlag();

extern	void ComputeDivMod();




#define RAND_MAX    255
#define NB_TRI		3
#define SPEED		4

					
unsigned char   x[3*NB_TRI],y[3*NB_TRI];
char			ix[3*NB_TRI],iy[3*NB_TRI];



unsigned int	CurrentPattern=0;

unsigned char	LeftPattern[]=
{
    64+1+2+4+8+16+32,
    64+1+2+4+8+16,
    64+1+2+4+8,
    64+1+2+4,
    64+1+2,
    64+1,
};

unsigned char	RightPattern[]=
{
    64+63-(1+2+4+8+16+32),
    64+63-(1+2+4+8+16),
    64+63-(1+2+4+8),
    64+63-(1+2+4),
    64+63-(1+2),
    64+63-(1),
};


unsigned char	Pattern[]=
{
    /*
    // Tout vide
    64,
    64,
    64,
    64,
    64,
    64,
    64,
    64,
    */

    // Tout rempli
    64+ 1+ 2+ 4+ 8+16+32,
    64+ 1+ 2+ 4+ 8+16+32,
    64+ 1+ 2+ 4+ 8+16+32,
    64+ 1+ 2+ 4+ 8+16+32,
    64+ 1+ 2+ 4+ 8+16+32,
    64+ 1+ 2+ 4+ 8+16+32,
    64+ 1+ 2+ 4+ 8+16+32,
    64+ 1+ 2+ 4+ 8+16+32,

    // Lignes verticales
    64+ 1+    4+   16	,
    64+ 1+    4+   16	,
    64+ 1+    4+   16	,
    64+ 1+    4+   16	,
    64+ 1+    4+   16	,
    64+ 1+    4+   16	,
    64+ 1+    4+   16	,
    64+ 1+    4+   16	,

    // Diagonale
    64+ 1+	   16	,
    64+ 	 8	,
    64+       4 	,
    64+    2+	      32,
    64+ 1+	   16	,
    64+ 	 8	,
    64+       4 	,
    64+    2+	      32,

    /*
    // Lignes horizontales
    64+ 1+ 2+ 4+ 8+16+32,
    64,
    64+ 1+ 2+ 4+ 8+16+32,
    64,
    64+ 1+ 2+ 4+ 8+16+32,
    64,
    64+ 1+ 2+ 4+ 8+16+32,
    64,
    */

    // Tramage
    64+ 1+    4+   16	,
    64+    2+	 8+   32,
    64+ 1+    4+   16	,
    64+    2+	 8+   32,
    64+ 1+    4+   16	,
    64+    2+	 8+   32,
    64+ 1+    4+   16	,
    64+    2+	 8+   32,

    // Diagonale 2
    64+ 1+	   16	,
    64+    2+	      32,
    64+       4 	,
    64+ 	 8	,
    64+ 1+	   16	,
    64+    2+	      32,
    64+       4 	,
    64+ 	 8	,

    // Croisillons
    64+ 1+    4+   16	,
    64			,
    64+ 1+    4+   16	,
    64			,
    64+ 1+    4+   16	,
    64			,
    64+ 1+    4+   16	,
    64			,
};






int random(unsigned int value)
{
    GetRand();
    return RandomValue&3;
}







void AddTriangle(unsigned char x0,unsigned char y0,unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2,unsigned char pattern)
{
    X0=x0;
    Y0=y0;
    X1=x1;
    Y1=y1;
    AddLineASM();
    X0=x0;
    Y0=y0;
    X1=x2;
    Y1=y2;
    AddLineASM();
    X0=x2;
    Y0=y2;
    X1=x1;
    Y1=y1;
    AddLineASM();

    CurrentPattern=pattern<<3;
    FillTablesASM();
}




void main()
{
	int				delay;
    unsigned char   pattern;
    unsigned char   i,j;

    char	    flag=1;

	paper(1);
	ink(4);
	hires();
	paper(4);
	ink(3);

	printf("PolyBench\n");
	
    ComputeDivMod();
    InitTables();


	//
	// Initialise triangles
	//
    j=0;
    for (i=0;i<NB_TRI;i++)
    {
		x[0+j]=120;
		y[0+j]=80;
		x[1+j]=80;
		y[1+j]=140;
		x[2+j]=200;
		y[2+j]=120;

		ix[0+j]=2;
		iy[0+j]=1;
		ix[1+j]=-1;
		iy[1+j]=+3;
		ix[2+j]=+1;
		iy[2+j]=-2;

		j+=3;
    }


	//
	// Move the triangles around the screen
	//
    while (1)
    {
		*(unsigned int*)0x276=0;

		delay=200;
		
		while (delay--)
		{	    
			pattern++;
			if (pattern>6)	pattern=1;
			pattern=1;
	
			ClearAndSwapFlag();
	
			j=0;
			for (i=0;i<NB_TRI;i++)
			{
				AddTriangle(x[0+j],y[0+j],x[1+j],y[1+j],x[2+j],y[2+j],(i&3));
				j+=3;
			}
	
			for (i=0;i<3*NB_TRI;i++)
			{
				x[i]+=ix[i];
				y[i]+=iy[i];
				if (x[i]>220)   ix[i]=-random(SPEED);
				if (x[i]<20)    ix[i]=random(SPEED);
				if (y[i]>195)   iy[i]=-random(SPEED);
				if (y[i]<4)		iy[i]=random(SPEED);
			}
		}
		
		delay=65536-(*(unsigned int*)0x276);
		printf(" %d",delay);
		
    }
}



